Index: XIOS/dev/branch_yushan/src/buffer_client.cpp
===================================================================
--- XIOS/dev/branch_yushan/src/buffer_client.cpp	(revision 1069)
+++ XIOS/dev/branch_yushan/src/buffer_client.cpp	(revision 1070)
@@ -81,6 +81,4 @@
       traceOn();
       if (flag == true) pending = false;
-
-      //printf("\ncheckbuffer, flag = %d, pending = %d; request = %p, count = %d\n", flag, pending, &request, count);
     }
 
Index: XIOS/dev/branch_yushan/src/client.cpp
===================================================================
--- XIOS/dev/branch_yushan/src/client.cpp	(revision 1069)
+++ XIOS/dev/branch_yushan/src/client.cpp	(revision 1070)
@@ -51,5 +51,4 @@
           int myColor ;
           int i,c ;
-          //MPI_Comm newComm ;
 
           MPI_Comm_size(CXios::globalComm,&size) ;
@@ -229,7 +228,5 @@
 
       MPI_Comm_rank(intraComm,&rank) ;
-      
-      //printf("CClient::finalize called isServer = %d\n", CXios::isServer);
- 
+       
       if (!CXios::isServer)
       {
@@ -238,5 +235,4 @@
         {
           MPI_Send(&msg,1,MPI_INT,0,0,interComm) ;
-          //printf(" CClient : send finalize sign to server 0\n");
         }
       }
@@ -254,5 +250,5 @@
       {
         if (CXios::usingOasis) oasis_finalize();
-        else {MPI_Finalize() ; printf("CClient::finalize called MPI_finalize\n");}
+        else  MPI_Finalize(); 
       }
       
Index: XIOS/dev/branch_yushan/src/client_client_dht_template_impl.hpp
===================================================================
--- XIOS/dev/branch_yushan/src/client_client_dht_template_impl.hpp	(revision 1069)
+++ XIOS/dev/branch_yushan/src/client_client_dht_template_impl.hpp	(revision 1070)
@@ -107,6 +107,4 @@
                                                                  int level)
 {
-  int clientRank;
-  MPI_Comm_rank(commLevel,&clientRank);
   int groupRankBegin = this->getGroupBegin()[level];
   int nbClient = this->getNbInGroup()[level];
@@ -200,11 +198,6 @@
 
   std::vector<ep_lib::MPI_Status> status(request.size());
-
-  //printf("1(%d): calling wait all for %lu requests\n", clientRank, request.size());
-
   MPI_Waitall(request.size(), &request[0], &status[0]);
 
-
-  //printf("               1(%d): calling wait all for %lu requests OK\n", clientRank, request.size());
 
   CArray<size_t,1>* tmpGlobalIndex;
@@ -311,8 +304,6 @@
 
   std::vector<ep_lib::MPI_Status> statusOnReturn(requestOnReturn.size());
-  //printf("2(%d): calling wait all for %lu requests\n", clientRank, requestOnReturn.size());
   MPI_Waitall(requestOnReturn.size(), &requestOnReturn[0], &statusOnReturn[0]);
 
-  //printf("            2(%d): calling wait all for %lu requests OK\n", clientRank, requestOnReturn.size());
 
   Index2VectorInfoTypeMap indexToInfoMapping;
@@ -383,5 +374,4 @@
                                                             int level)
 {
-  //printf("in computeDistributedIndex(const Index2VectorInfoTypeMap& indexInfoMap, const MPI_Comm& commLevel, int level)\n");
   int clientRank;
   MPI_Comm_rank(commLevel,&clientRank);
@@ -433,11 +423,8 @@
     {
       client2ClientIndex[indexClient + groupRankBegin][sendNbIndexBuff[indexClient]] = it->first;;
-  //          ProcessDHTElement<InfoType>::packElement(it->second, client2ClientInfo[indexClient + groupRankBegin], sendNbInfo[indexClient]);
       ProcessDHTElement<InfoType>::packElement(infoTmp[idx], client2ClientInfo[indexClient + groupRankBegin], sendNbInfo[indexClient]);
       ++sendNbIndexBuff[indexClient];
     }
   }
-
-  //printf("check 4 OK. clientRank = %d\n", clientRank);
 
   // Calculate from how many clients each client receive message.
@@ -446,5 +433,4 @@
   sendRecvRank(level, sendBuff, sendNbIndexBuff,
                recvRankClient, recvNbIndexClientCount);
-  //printf("sendRecvRank OK\n");
 
   int recvNbIndexCount = 0;
@@ -459,6 +445,4 @@
     recvInfoBuff = new unsigned char[recvNbIndexCount*ProcessDHTElement<InfoType>::typeSize()];
   }
-
-  //printf("check 5 OK. clientRank = %d\n", clientRank);
 
   // If a client holds information about index and the corresponding which don't belong to it,
@@ -483,6 +467,4 @@
   }
 
-  //printf("check 6 OK. clientRank = %d\n", clientRank);
-
   boost::unordered_map<int, size_t* >::iterator itbIndex = client2ClientIndex.begin(), itIndex,
                                                 iteIndex = client2ClientIndex.end();
@@ -493,6 +475,4 @@
   }
 
-  //printf("check 7 OK. clientRank = %d\n", clientRank);
-
   boost::unordered_map<int, unsigned char*>::iterator itbInfo = client2ClientInfo.begin(), itInfo,
                                                       iteInfo = client2ClientInfo.end();
@@ -503,5 +483,4 @@
   }
 
-  //printf("check 8 OK. clientRank = %d\n", clientRank);
   std::vector<ep_lib::MPI_Status> status(request.size());
 
@@ -528,6 +507,4 @@
   }
 
-  //printf("check 9 OK. clientRank = %d\n", clientRank);
-
   if (0 != recvNbIndexCount)
   {
@@ -543,5 +520,4 @@
       delete [] it->second;
 
-  //printf("check 10 OK. clientRank = %d\n", clientRank);
   // Ok, now do something recursive
   if (0 < level)
@@ -608,5 +584,4 @@
   ep_lib::MPI_Request request;
   requestSendInfo.push_back(request);
-  //printf("MPI_IsendInfo(info, infoSize, MPI_CHAR,... char count = %d, dest = %d, buf_size = %d\n", infoSize, clientDestRank, sizeof(*info) );
   MPI_Isend(info, infoSize, MPI_CHAR,
             clientDestRank, MPI_DHT_INFO, clientIntraComm, &(requestSendInfo.back()));
@@ -717,9 +692,6 @@
   }
   
-  int clientRank;
-  MPI_Comm_rank(this->internalComm_,&clientRank);
-  //printf("4(%d): calling wait all for %lu requests\n", clientRank, sendNbRank.size()+recvNbRank.size());
+  
   MPI_Waitall(sendNbRank.size()+recvNbRank.size(), &request[0], &requestStatus[0]);
-  //printf("        4(%d): calling wait all for %lu requests OK\n", clientRank, sendNbRank.size()+recvNbRank.size());
 }
 
@@ -738,7 +710,4 @@
                                                  std::vector<int>& recvNbRank, std::vector<int>& recvNbElements)
 {
-  int myRank;
-  MPI_Comm_rank(MPI_COMM_WORLD, &myRank);
-  //printf("myRank = %d, in sendRecvRank(int level, const std::vector<int>& sendNbRank, const std::vector<int>& sendNbElements, std::vector<int>& recvNbRank, std::vector<int>& recvNbElements)\n", myRank);
   int groupBegin = this->getGroupBegin()[level];
 
@@ -757,12 +726,9 @@
   for (int idx = 0; idx < recvBuffSize; ++idx)
   {
-    //printf("myRank = %d starts irecv with src = %d, tag = %d, idx = %d\n", myRank, recvRank[idx], MPI_DHT_INDEX_0, idx);
     MPI_Irecv(&recvBuff[0]+2*idx, 2, MPI_INT,
               recvRank[idx], MPI_DHT_INDEX_0, this->internalComm_, &request[nRequest]);
-    //printf("myRank = %d MPI_Irecv OK, idx = %d, nRequest = %d\n", myRank, idx, nRequest);
     ++nRequest;
   }
 
-  //printf("myRank = %d, check 1 OK\n", myRank);
 
   for (int idx = 0; idx < sendBuffSize; ++idx)
@@ -775,8 +741,6 @@
   for (int idx = 0; idx < sendBuffSize; ++idx)
   {
-    //printf("myRank = %d starts isend with dest = %d, tag = %d, idx = %d\n", myRank, sendRank[idx], MPI_DHT_INDEX_0, idx);
     MPI_Isend(&sendBuff[idx*2], 2, MPI_INT,
               sendRank[idx], MPI_DHT_INDEX_0, this->internalComm_, &request[nRequest]);
-    //printf("myRank = %d MPI_Isend OK, idx = %d, nRequest = %d\n", myRank, idx, nRequest);
     ++nRequest;
   }
@@ -784,13 +748,6 @@
   MPI_Barrier(this->internalComm_);
 
-  //printf("myRank = %d, check 2 OK\n", myRank);
-
-  int clientRank;
-  MPI_Comm_rank(this->internalComm_,&clientRank);
-
-  //printf("5(%d): calling wait all for %lu requests\n", myRank, sendBuffSize+recvBuffSize);
+
   MPI_Waitall(sendBuffSize+recvBuffSize, &request[0], &requestStatus[0]);
-  //printf("            5(%d): calling wait all for %lu requests OK\n", myRank, sendBuffSize+recvBuffSize);
-  //printf("check 3 OK\n");
 
   int nbRecvRank = 0, nbRecvElements = 0;
@@ -805,6 +762,5 @@
     }
   }
-  //printf("check 4 OK\n");
-}
-
-}
+}
+
+}
Index: XIOS/dev/branch_yushan/src/context_client.cpp
===================================================================
--- XIOS/dev/branch_yushan/src/context_client.cpp	(revision 1069)
+++ XIOS/dev/branch_yushan/src/context_client.cpp	(revision 1070)
@@ -116,5 +116,5 @@
       while (parentServer->server->hasPendingEvent())
       {
-       parentServer->server->eventLoop(); //printf("parentServer->server->eventLoop()\n");
+       parentServer->server->eventLoop();
       }
     }
Index: XIOS/dev/branch_yushan/src/context_server.cpp
===================================================================
--- XIOS/dev/branch_yushan/src/context_server.cpp	(revision 1069)
+++ XIOS/dev/branch_yushan/src/context_server.cpp	(revision 1070)
@@ -76,5 +76,4 @@
     for(rank=0;rank<commSize;rank++)
     {
-      //printf("in CContextServer::listen, rank = %d, commSize = %d, pendingRequest.find(rank) = %d\n", rank, commSize, pendingRequest.find(rank));
       if (pendingRequest.find(rank)==pendingRequest.end())
       {
@@ -92,5 +91,4 @@
             mapBufferSize_.insert(std::make_pair(rank, buffSize));
             it=(buffers.insert(pair<int,CServerBuffer*>(rank,new CServerBuffer(buffSize)))).first;
-            //printf("find message, is buffer end, receiving, buffSize = %d, rank = %d, commSize = %d\n", buffSize, rank, commSize);
           }
           else
@@ -103,5 +101,4 @@
               ep_lib::MPI_Irecv(addr,count,MPI_CHAR,rank,20,interComm,&pendingRequest[rank]);
               bufferRequest[rank]=addr;
-              //printf("find message, i-receiving to buffer %p, rank = %d, commSize = %d\n", addr, rank, commSize);
             }
           }
@@ -148,7 +145,5 @@
 
     CBufferIn buffer(buff,count);
-    //char* startBuffer,endBuffer;
     int size;
-    //int offset;
     size_t timeLine;
     map<size_t,CEventServer*>::iterator it;
Index: XIOS/dev/branch_yushan/src/cxios.cpp
===================================================================
--- XIOS/dev/branch_yushan/src/cxios.cpp	(revision 1069)
+++ XIOS/dev/branch_yushan/src/cxios.cpp	(revision 1070)
@@ -86,10 +86,4 @@
       
     globalComm = passage[omp_get_thread_num()];
-    
-    // int tmp_size;
-    // MPI_Comm_size(globalComm, &tmp_size);
-    // if(isClient) printf("Client : globalcomm size = %d\n", tmp_size);
-    // if(isServer) printf("Server : globalcomm size = %d\n", tmp_size);
-
     
   }
Index: XIOS/dev/branch_yushan/src/interface/c/icdata.cpp
===================================================================
--- XIOS/dev/branch_yushan/src/interface/c/icdata.cpp	(revision 1069)
+++ XIOS/dev/branch_yushan/src/interface/c/icdata.cpp	(revision 1070)
@@ -95,9 +95,6 @@
      comm = ep_lib::EP_Comm_f2c(static_cast< int >(*f_comm));
 
-    
      CClient::registerContext(str,comm);
-     
-     //printf("icdata.cpp: client register context %s : %p\n", context_id, &comm);
-     
+          
      CTimer::get("XIOS init context").suspend();
      CTimer::get("XIOS").suspend();
@@ -289,5 +286,4 @@
       {
         CVariable::get(context->getId(), varIdStr)->setData<double>(data);
-        //CVariable::get(context->getId(), varIdStr)->sendValue();
       }
 
@@ -310,5 +306,4 @@
       {
         CVariable::get(context->getId(), varIdStr)->setData<float>(data);
-        //CVariable::get(context->getId(), varIdStr)->sendValue();
       }
 
@@ -331,5 +326,4 @@
       {
         CVariable::get(context->getId(), varIdStr)->setData<int>(data);
-        //CVariable::get(context->getId(), varIdStr)->sendValue();
       }
 
@@ -353,5 +347,4 @@
       {
         CVariable::get(context->getId(), varIdStr)->setData<bool>(data);
-        //CVariable::get(context->getId(), varIdStr)->sendValue();
       }
 
@@ -379,5 +372,4 @@
       {
         CVariable::get(context->getId(), varIdStr)->setData<string>(dataStr);
-        //CVariable::get(context->getId(), varIdStr)->sendValue();
       }
 
Index: XIOS/dev/branch_yushan/src/io/onetcdf4.cpp
===================================================================
--- XIOS/dev/branch_yushan/src/io/onetcdf4.cpp	(revision 1069)
+++ XIOS/dev/branch_yushan/src/io/onetcdf4.cpp	(revision 1070)
@@ -47,5 +47,4 @@
          wmpi = comm && !multifile;
          
-         //ep_lib::MPI_Info info_null;
 
          if (wmpi)
@@ -57,13 +56,9 @@
             if (wmpi)
             {
-               // printf("start creating file with createPar\n");
-               //CNetCdfInterface::createPar(filename, mode, static_cast<MPI_Comm>(comm->mpi_comm), static_cast<MPI_Info>(info_null.mpi_info), this->ncidp);
                CNetCdfInterface::createPar(filename, mode, static_cast<MPI_Comm>(comm->mpi_comm), MPI_INFO_NULL_STD, this->ncidp);
-               // printf("creating file with createPar\n");
             }
             else
             {
                CNetCdfInterface::create(filename, mode, this->ncidp);
-               // printf("creating file with create\n");  
             }  
                
@@ -76,13 +71,9 @@
             if (wmpi)
             {
-//               printf("start opening file with openPar\n");
-               // CNetCdfInterface::openPar(filename, mode, static_cast<MPI_Comm>(comm->mpi_comm), static_cast<MPI_Info>(info_null.mpi_info), this->ncidp);
                CNetCdfInterface::openPar(filename, mode, static_cast<MPI_Comm>(comm->mpi_comm), MPI_INFO_NULL_STD, this->ncidp);
-//               printf("opening file with openPar\n");
             }
             else
             {
                CNetCdfInterface::open(filename, mode, this->ncidp);
-               // printf("opening file with open\n");
             }
 
Index: XIOS/dev/branch_yushan/src/node/context.cpp
===================================================================
--- XIOS/dev/branch_yushan/src/node/context.cpp	(revision 1069)
+++ XIOS/dev/branch_yushan/src/node/context.cpp	(revision 1070)
@@ -390,8 +390,4 @@
    void CContext::closeDefinition(void)
    {
-     int myRank;
-     MPI_Comm_rank(MPI_COMM_WORLD, &myRank);
-
-     //printf("myRank = %d, hasClient = %d, hasServer = %d\n", myRank, hasClient, hasServer);
 
      // There is nothing client need to send to server
@@ -400,31 +396,26 @@
        // After xml is parsed, there are some more works with post processing
        postProcessing(); 
-       //printf("myRank = %d,                postProcessing OK\n", myRank);
-     }
-     setClientServerBuffer(); //printf("myRank = %d, setClientServerBuffer OK\n", myRank);
-
-     //printf("hasClient = %d, hasServer = %d\n", hasClient, hasServer);
+     }
+     setClientServerBuffer(); 
 
      if (hasClient && !hasServer)
      {
       // Send all attributes of current context to server
-      this->sendAllAttributesToServer(); //printf("myRank = %d, this->sendAllAttributesToServer OK\n", myRank);
+      this->sendAllAttributesToServer();
 
       // Send all attributes of current calendar
       CCalendarWrapper::get(CCalendarWrapper::GetDefName())->sendAllAttributesToServer();
-      //printf("myRank = %d, CCalendarWrapper::get(CCalendarWrapper::GetDefName())->sendAllAttributesToServer OK\n", myRank);
 
       // We have enough information to send to server
       // First of all, send all enabled files
-       sendEnabledFiles();  //printf("myRank = %d, sendEnabledFiles OK\n", myRank);
+       sendEnabledFiles(); 
 
       // Then, send all enabled fields
-       sendEnabledFields();  //printf("myRank = %d, sendEnabledFields OK\n", myRank);
+       sendEnabledFields(); 
 
       // At last, we have all info of domain and axis, then send them
-       sendRefDomainsAxis();  //printf("myRank = %d, sendRefDomainsAxis OK\n", myRank);
-
+       sendRefDomainsAxis(); 
       // After that, send all grid (if any)
-       sendRefGrid(); //printf("myRank = %d, sendRefGrid OK\n", myRank);
+       sendRefGrid(); 
     }
 
@@ -435,7 +426,7 @@
     if (hasClient)
     {
-      this->buildFilterGraphOfEnabledFields();  //printf("myRank = %d, buildFilterGraphOfEnabledFields OK\n", myRank);
-      buildFilterGraphOfFieldsWithReadAccess();  //printf("myRank = %d, buildFilterGraphOfFieldsWithReadAccess OK\n", myRank);
-      this->solveAllRefOfEnabledFields(true);  //printf("myRank = %d, solveAllRefOfEnabledFields OK\n", myRank);
+      this->buildFilterGraphOfEnabledFields();  
+      buildFilterGraphOfFieldsWithReadAccess();  
+      this->solveAllRefOfEnabledFields(true); 
     }
 
@@ -448,7 +439,7 @@
     if (hasClient)
     {
-      sendCreateFileHeader();  //printf("myRank = %d, sendCreateFileHeader OK\n", myRank);
-
-      startPrefetchingOfEnabledReadModeFiles();  //printf("myRank = %d, startPrefetchingOfEnabledReadModeFiles OK\n", myRank);
+      sendCreateFileHeader(); 
+
+      startPrefetchingOfEnabledReadModeFiles();  
     }
    }
Index: XIOS/dev/branch_yushan/src/node/domain.cpp
===================================================================
--- XIOS/dev/branch_yushan/src/node/domain.cpp	(revision 1069)
+++ XIOS/dev/branch_yushan/src/node/domain.cpp	(revision 1070)
@@ -1303,27 +1303,18 @@
    void CDomain::checkAttributesOnClientAfterTransformation()
    {
-     int myRank;
-     MPI_Comm_rank(MPI_COMM_WORLD, &myRank);
-
-     CContext* context=CContext::getCurrent() ;  //printf("myRank = %d, CContext::getCurrent OK\n", myRank);
-
-     //printf("myRank = %d, this->isClientAfterTransformationChecked = %d\n", myRank, this->isClientAfterTransformationChecked);
+     
+     CContext* context=CContext::getCurrent() ;
+
      if (this->isClientAfterTransformationChecked) return;
-     //printf("myRank = %d, context->hasClient = %d\n", myRank, context->hasClient);
      if (context->hasClient)
      {
-       this->checkMask();  //printf("myRank = %d, this->checkMask OK\n", myRank);
-       //printf("myRank = %d, hasLonLat = %d, hasArea = %d, isCompressible_ = %d\n", myRank, hasLonLat, hasArea, isCompressible_);
+       this->checkMask(); 
        if (hasLonLat || hasArea || isCompressible_) 
         {
-          //printf("myRank = %d, start this->computeConnectedServer\n", myRank);
           this->computeConnectedServer();
-          //printf("myRank = %d, this->computeConnectedServer OK\n", myRank);
-        }
-       //printf("myRank = %d, hasLonLat = %d\n", myRank, hasLonLat);
+        }
        if (hasLonLat) 
         {
           this->completeLonLatClient();
-          //printf("myRank = %d, this->completeLonLatClient OK\n", myRank);
         }
      }
@@ -1460,6 +1451,4 @@
   void CDomain::computeConnectedServer(void)
   {
-    int myRank;
-    MPI_Comm_rank(MPI_COMM_WORLD, &myRank);
 
     CContext* context=CContext::getCurrent() ;
@@ -1576,18 +1565,10 @@
     else serverDescription.computeServerGlobalIndexInRange(std::make_pair<size_t,size_t>(indexBegin, indexEnd), 1);
 
-    //printf("myRank = %d, check 7 OK\n", myRank);
-
     CClientServerMapping* clientServerMap = new CClientServerMappingDistributed(serverDescription.getGlobalIndexRange(),
                                                                                 client->intraComm);
-    //printf("myRank = %d new OK\n", myRank);
-
     clientServerMap->computeServerIndexMapping(globalIndexDomain);  
-    //printf("myRank = %d, clientServerMap->computeServerIndexMapping(globalIndexDomain) OK\n", myRank);
     
     const CClientServerMapping::GlobalIndexMap& globalIndexDomainOnServer = clientServerMap->getGlobalIndexOnServer();
-    //printf("myRank = %d, clientServerMap->getGlobalIndexOnServer OK\n", myRank);
     
-    //printf("myRank = %d, check 8 OK\n", myRank);
-
     CClientServerMapping::GlobalIndexMap::const_iterator it  = globalIndexDomainOnServer.begin(),
                                                          ite = globalIndexDomainOnServer.end();
@@ -1622,6 +1603,4 @@
     }
 
-    //printf("myRank = %d, check 9 OK\n", myRank);
-
     connectedServerRank_.clear();
     for (it = globalIndexDomainOnServer.begin(); it != ite; ++it) {
@@ -1632,5 +1611,4 @@
 
     delete clientServerMap;
-    //printf("myRank = %d, check 10 OK\n", myRank);
   }
 
Index: XIOS/dev/branch_yushan/src/node/field.cpp
===================================================================
--- XIOS/dev/branch_yushan/src/node/field.cpp	(revision 1069)
+++ XIOS/dev/branch_yushan/src/node/field.cpp	(revision 1070)
@@ -621,9 +621,7 @@
    void CField::solveAllReferenceEnabledField(bool doSending2Server)
    {
-     int myRank;
-     MPI_Comm_rank(MPI_COMM_WORLD, &myRank);
-
-     CContext* context = CContext::getCurrent();  //printf("my_Rank = %d, CContext* context = CContext::getCurrent OK\n", myRank);
-     solveOnlyReferenceEnabledField(doSending2Server);  //printf("my_Rank = %d, solveOnlyReferenceEnabledField(doSending2Server) OK\n", myRank);
+
+     CContext* context = CContext::getCurrent(); 
+     solveOnlyReferenceEnabledField(doSending2Server);
 
      if (!areAllReferenceSolved)
@@ -633,9 +631,9 @@
         if (context->hasClient)
         {
-          solveRefInheritance(true);  //printf("my_Rank = %d, solveRefInheritance(true) OK\n", myRank);
+          solveRefInheritance(true);  
           if (hasDirectFieldReference()) 
           {
             getDirectFieldReference()->solveAllReferenceEnabledField(false); 
-            //printf("my_Rank = %d, getDirectFieldReference()->solveAllReferenceEnabledField(false) OK\n", myRank);
+            
           }
         }
@@ -643,18 +641,18 @@
         {
           solveServerOperation();
-          //printf("my_Rank = %d, solveServerOperation OK\n", myRank);
+          
         }
 
-        solveGridReference();  //printf("my_Rank = %d, solveGridReference OK\n", myRank);
-     }
-
-     solveGridDomainAxisRef(doSending2Server);  //printf("my_Rank = %d, solveGridDomainAxisRef(doSending2Server) OK\n", myRank);
+        solveGridReference();  
+     }
+
+     solveGridDomainAxisRef(doSending2Server); 
 
      if (context->hasClient)
      {
-       solveTransformedGrid();  //printf("my_Rank = %d, solveTransformedGrid OK\n", myRank);
-     }
-
-     solveCheckMaskIndex(doSending2Server);  //printf("FIELD.CPP: my_Rank = %d, solveCheckMaskIndex(doSending2Server) OK\n", myRank);
+       solveTransformedGrid(); 
+     }
+
+     solveCheckMaskIndex(doSending2Server); 
    }
 
Index: XIOS/dev/branch_yushan/src/node/grid.cpp
===================================================================
--- XIOS/dev/branch_yushan/src/node/grid.cpp	(revision 1069)
+++ XIOS/dev/branch_yushan/src/node/grid.cpp	(revision 1070)
@@ -166,9 +166,7 @@
    void CGrid::checkAttributesAfterTransformation()
    {
-      int myRank;
-      MPI_Comm_rank(MPI_COMM_WORLD, &myRank);
-
-      setAxisList();  //printf("myRank = %d, setAxisList OK\n", myRank);
-      std::vector<CAxis*> axisListP = this->getAxis();  //printf("myRank = %d, this->getAxis OK\n", myRank);
+      
+      setAxisList();  
+      std::vector<CAxis*> axisListP = this->getAxis(); 
       if (!axisListP.empty())
       {
@@ -183,5 +181,5 @@
             axisPositionInGrid_.push_back(idx);
             ++idx;
-            //printf("myRank = %d, axisPositionInGrid_.push_back OK\n", myRank);
+            
           }
           else if (2 == elementDimension) idx += 2;
@@ -191,17 +189,14 @@
         {
           axisListP[i]->checkAttributesOnClientAfterTransformation(globalDim_,axisPositionInGrid_[i]);
-          //printf("myRank = %d, axisListP[%d/%d]->checkAttributesOnClientAfterTransformation OK\n", myRank, i, axisListP.size());
-        }
-      }
-
-      setDomainList(); //printf("myRank = %d, setDomainList OK\n", myRank);
-      std::vector<CDomain*> domListP = this->getDomains(); //printf("myRank = %d, this->getDomains OK\n", myRank);
+        }
+      }
+
+      setDomainList(); 
+      std::vector<CDomain*> domListP = this->getDomains();
       if (!domListP.empty())
       {
         for (int i = 0; i < domListP.size(); ++i)
         {
-          //printf("myRank = %d, start domListP[%d]->checkAttributesOnClientAfterTransformation\n", myRank, i);
           domListP[i]->checkAttributesOnClientAfterTransformation();
-          //printf("myRank = %d, domListP[%d]->checkAttributesOnClientAfterTransformation OK\n", myRank, i);
         }
       }
Index: XIOS/dev/branch_yushan/src/server.cpp
===================================================================
--- XIOS/dev/branch_yushan/src/server.cpp	(revision 1069)
+++ XIOS/dev/branch_yushan/src/server.cpp	(revision 1070)
@@ -165,5 +165,5 @@
       {
         if (CXios::usingOasis) oasis_finalize();
-        //else  {MPI_Finalize() ; printf("CServer::finalize called MPI_finalize\n");}
+        //else  {MPI_Finalize() ;}
       }
 
Index: XIOS/dev/branch_yushan/src/transformation/grid_transformation.cpp
===================================================================
--- XIOS/dev/branch_yushan/src/transformation/grid_transformation.cpp	(revision 1069)
+++ XIOS/dev/branch_yushan/src/transformation/grid_transformation.cpp	(revision 1070)
@@ -531,7 +531,5 @@
 
   status.resize(requests.size());
-  //printf("(%d) src/transformation/grid_transformation 1st waitall\n", clientRank);
   MPI_Waitall(requests.size(), &requests[0], &status[0]);
-  //printf("(%d) src/transformation/grid_transformation 1st waitall OK\n", clientRank);
 
   // Okie, now use the mask to identify which index source we need to send, then also signal the destination which masked index we will return
@@ -585,7 +583,5 @@
   }
   status.resize(requests.size());
-  //printf("(%d) src/transformation/grid_transformation 2nd waitall\n", clientRank);
   MPI_Waitall(requests.size(), &requests[0], &status[0]);
-  //printf("(%d) src/transformation/grid_transformation 2nd waitall OK\n", clientRank);
 
   // Cool, now we can fill in local index of grid destination (counted for masked index)